﻿/// <summary>
/// source: Http://www.WayneCliffordBarker.co.za
/// license: free to use by any individual or company for what ever purpose.
/// disclaimer: All content provided on this site "www.waynecliffordbarker.co.za" is for informational purposes only. Although the owner takes care to represent accurate content, the owner makes no representations as to the accuracy or completeness of any information on this site or found by following any link on this site. Neither the  owner of www.waynecliffordbarker.co.za nor any author of the site will be liable for any errors or omissions in this information nor for the availability of this information. The owner of www.waynecliffordbarker.co.za nor any author of the site will not be liable for any losses, injuries, or damages from the display or use of this information obtained from this site.
/// </summary>

using System;
using System.Collections.Generic;
using System.Text;
using WayneCliffordBarker.RoutingEngine.Interface;

namespace WayneCliffordBarker.RoutingEngine.Abstract
{
    public abstract class PersistMechanism
    {
        public PersistMechanism()
        {

        }

        protected internal Ilogger Logger { get; set; }

        public PersistMechanism(string config)
        {

        }

        public bool Persist(IEnumerable<string> data)
        {
            bool result = PersistData(data);
            this?.Logger?.WriteInformation("Persistance complete");

            return result;
        }

        protected abstract bool PersistData(IEnumerable<string> data);
    }
}
