﻿/// <summary>
/// source: Http://www.WayneCliffordBarker.co.za
/// license: free to use by any individual or company for what ever purpose.
/// disclaimer: All content provided on this site "www.waynecliffordbarker.co.za" is for informational purposes only. Although the owner takes care to represent accurate content, the owner makes no representations as to the accuracy or completeness of any information on this site or found by following any link on this site. Neither the  owner of www.waynecliffordbarker.co.za nor any author of the site will be liable for any errors or omissions in this information nor for the availability of this information. The owner of www.waynecliffordbarker.co.za nor any author of the site will not be liable for any losses, injuries, or damages from the display or use of this information obtained from this site.
/// </summary>

using System;
using System.Collections.Generic;
using System.Text;
using WayneCliffordBarker.RoutingEngine.Abstract;

namespace HelloWorldRouting.MyRoutingClasses.Message2
{
    public class TransformMessage2ToJson : DataTransformer
    {
        public TransformMessage2ToJson() : base()
        {
        }
        
        protected override IEnumerable<string> TransformData(string data)
        {
            this?.Logger?.WriteInformation("Data to transform: " + data);

            string[] result = data.Split("|");

            string json = string.Format("id={0}, title={1}, Name={2}, MiddleName={3}, Surname={4}",result[0], result[1], result[2], result[3], result[4]);
            json = "{" + json + "}";

            this?.Logger?.WriteInformation("Transformed data: ");
            this?.Logger?.WriteInformation(json);

            List<string> result2 = new List<string>();
            result2.Add(json);

            return result2;
        }
    }
}
